VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "EFkit - Enhanced Fujita Scale Damage Assessment Toolkit"
   ClientHeight    =   8400
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   14985
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   8400
   ScaleWidth      =   14985
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnHelp 
      Caption         =   "Help"
      Height          =   255
      Left            =   11580
      TabIndex        =   19
      TabStop         =   0   'False
      Top             =   6240
      Width           =   1575
   End
   Begin VB.CommandButton btnReference 
      Caption         =   "Reference"
      Height          =   255
      Left            =   13380
      TabIndex        =   18
      TabStop         =   0   'False
      Top             =   6240
      Width           =   1515
   End
   Begin VB.TextBox txtBigText 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   7215
      Left            =   120
      MousePointer    =   1  'Arrow
      MultiLine       =   -1  'True
      TabIndex        =   17
      Top             =   180
      Visible         =   0   'False
      Width           =   11355
   End
   Begin VB.Frame frameExamples 
      BorderStyle     =   0  'None
      Height          =   1755
      Left            =   13080
      TabIndex        =   13
      Top             =   4260
      Visible         =   0   'False
      Width           =   855
      Begin VB.VScrollBar sbExample 
         Height          =   1515
         Left            =   180
         TabIndex        =   14
         Top             =   240
         Width           =   435
      End
      Begin VB.Label Label4 
         Alignment       =   2  'Center
         Caption         =   "Examples"
         Height          =   195
         Left            =   60
         TabIndex        =   15
         Top             =   0
         Width           =   735
      End
   End
   Begin VB.Frame frameTune 
      BorderStyle     =   0  'None
      Height          =   4035
      Left            =   11760
      TabIndex        =   9
      Top             =   180
      Visible         =   0   'False
      Width           =   975
      Begin VB.VScrollBar sbFineTune 
         Height          =   3255
         LargeChange     =   5
         Left            =   420
         TabIndex        =   10
         Top             =   540
         Width           =   495
      End
      Begin VB.Label Label5 
         Alignment       =   2  'Center
         Caption         =   "Fine Tune"
         Height          =   375
         Left            =   420
         TabIndex        =   16
         Top             =   0
         Width           =   495
      End
      Begin VB.Label lblUpper 
         Alignment       =   1  'Right Justify
         Caption         =   "999"
         Height          =   255
         Left            =   0
         TabIndex        =   12
         Top             =   540
         Width           =   315
      End
      Begin VB.Label lblLower 
         Alignment       =   1  'Right Justify
         Caption         =   "999"
         Height          =   255
         Left            =   0
         TabIndex        =   11
         Top             =   3600
         Width           =   315
      End
   End
   Begin VB.Frame frameResult 
      Height          =   1695
      Left            =   11640
      TabIndex        =   5
      Top             =   6600
      Visible         =   0   'False
      Width           =   3315
      Begin VB.TextBox txtWind 
         Alignment       =   2  'Center
         BackColor       =   &H00C0FFFF&
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   24
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   675
         Left            =   1680
         TabIndex        =   7
         Top             =   180
         Width           =   1275
      End
      Begin VB.TextBox txtEF 
         Alignment       =   2  'Center
         BackColor       =   &H00C0FFFF&
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   24
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   555
         Left            =   1680
         TabIndex        =   6
         Top             =   1020
         Width           =   1275
      End
      Begin VB.Label Label1 
         Alignment       =   1  'Right Justify
         Caption         =   "Wind Speed (mph)"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   480
         Width           =   1335
      End
   End
   Begin VB.VScrollBar sbDOD 
      Height          =   3315
      Left            =   13200
      TabIndex        =   2
      Top             =   660
      Width           =   495
   End
   Begin VB.VScrollBar sbDI 
      Height          =   3315
      Left            =   14280
      TabIndex        =   1
      Top             =   660
      Width           =   495
   End
   Begin VB.TextBox txtTxt 
      BackColor       =   &H00C0FFFF&
      Height          =   915
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   7500
      Width           =   11415
   End
   Begin VB.Label lblHelp6 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Previous DOD Example"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   1095
      Left            =   1140
      TabIndex        =   25
      Top             =   4860
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.Label lblHelp5 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Next DOD Example"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   1095
      Left            =   1140
      TabIndex        =   24
      Top             =   1320
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.Label lblHelp4 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Previous Degree of Damage"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   1095
      Left            =   5160
      TabIndex        =   23
      Top             =   4860
      Visible         =   0   'False
      Width           =   1335
   End
   Begin VB.Label lblHelp3 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Next Degree of Damage"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   1095
      Left            =   5220
      TabIndex        =   22
      Top             =   1380
      Visible         =   0   'False
      Width           =   1335
   End
   Begin VB.Label lblHelp2 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Previous Damage Indicator"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   1095
      Left            =   8820
      TabIndex        =   21
      Top             =   4920
      Visible         =   0   'False
      Width           =   1455
   End
   Begin VB.Label lblHelp1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Next Damage Indicator"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   1095
      Left            =   9000
      TabIndex        =   20
      Top             =   1320
      Visible         =   0   'False
      Width           =   1335
   End
   Begin VB.Line LineHelp3 
      BorderColor     =   &H000000FF&
      Visible         =   0   'False
      X1              =   120
      X2              =   11460
      Y1              =   3780
      Y2              =   3780
   End
   Begin VB.Line LineHelp2 
      BorderColor     =   &H000000FF&
      Visible         =   0   'False
      X1              =   3900
      X2              =   3900
      Y1              =   180
      Y2              =   7380
   End
   Begin VB.Line LineHelp1 
      BorderColor     =   &H000000FF&
      Visible         =   0   'False
      X1              =   7860
      X2              =   7860
      Y1              =   180
      Y2              =   7380
   End
   Begin VB.Line lineExampleDown 
      BorderColor     =   &H00FF0000&
      BorderWidth     =   3
      Visible         =   0   'False
      X1              =   60
      X2              =   3900
      Y1              =   7440
      Y2              =   7440
   End
   Begin VB.Line lineExampleUp 
      BorderColor     =   &H00FF0000&
      BorderWidth     =   3
      Visible         =   0   'False
      X1              =   60
      X2              =   3900
      Y1              =   60
      Y2              =   60
   End
   Begin VB.Line lineDODdown 
      BorderColor     =   &H000080FF&
      BorderWidth     =   3
      X1              =   3900
      X2              =   7860
      Y1              =   7440
      Y2              =   7440
   End
   Begin VB.Line lineDODup 
      BorderColor     =   &H000080FF&
      BorderWidth     =   3
      X1              =   3900
      X2              =   7860
      Y1              =   60
      Y2              =   60
   End
   Begin VB.Line lineDIdown 
      BorderColor     =   &H000000FF&
      BorderWidth     =   3
      X1              =   7860
      X2              =   11460
      Y1              =   7440
      Y2              =   7440
   End
   Begin VB.Line lineDIup 
      BorderColor     =   &H000000FF&
      BorderWidth     =   3
      X1              =   7860
      X2              =   11460
      Y1              =   60
      Y2              =   60
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Degree of Damage"
      Height          =   615
      Left            =   13080
      TabIndex        =   4
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Damage Indicator"
      Height          =   375
      Left            =   14160
      TabIndex        =   3
      Top             =   240
      Width           =   735
   End
   Begin VB.Image picPic 
      Height          =   7215
      Left            =   120
      Stretch         =   -1  'True
      Top             =   180
      Width           =   11355
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim SHOWDOD As Boolean
Dim SHOWEXAMPLE As Boolean
Dim ShowHelp As Boolean

Private Declare Function ShellExecute Lib "shell32.dll" _
      Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation _
      As String, ByVal lpFile As String, ByVal lpParameters As String, _
      ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long


Function Wind_To_EF(wind As Integer) As String
Dim EF As String

    If wind <= 64 Then
        EF = "N/A"
    ElseIf wind <= 85 Then
        EF = "EF0"
    ElseIf wind <= 110 Then
        EF = "EF1"
    ElseIf wind <= 135 Then
        EF = "EF2"
    ElseIf wind <= 165 Then
        EF = "EF3"
    ElseIf wind <= 200 Then
        EF = "EF4"
    Else
        EF = "EF5"
    End If

    Wind_To_EF = EF
    
End Function

Sub LoadConfiguration()
Dim buffer As String
Dim pattern As String


    frmSpash.Show
    DoEvents


    Open "EFkit.cfg" For Input As #1
    nDIs = 0
    Do
       Line Input #1, buffer
       If Left(buffer, 1) = "=" Then Exit Do
       nDIs = nDIs + 1
       DI_Title(nDIs) = buffer
       
       Line Input #1, DI_ID(nDIs)
       
       DI_Description(nDIs) = ""
       
       Do
         Line Input #1, buffer
         If Len(buffer) < 5 Then Exit Do
         If DI_Description(nDIs) = "" Then
           DI_Description(nDIs) = buffer
           DI_Description_Short(nDIs) = buffer
         Else
           DI_Description(nDIs) = DI_Description(nDIs) & vbCrLf & buffer
           DI_Description_Short(nDIs) = DI_Description_Short(nDIs) & "    " & buffer
         End If
       Loop
       
       Set DI_Example(nDIs) = LoadPicture("Examples\" & DI_ID(nDIs) & ".jpg")
       
       nDODs(nDIs) = 0
       Do
         Line Input #1, buffer
         If Len(buffer) < 5 Then Exit Do
         nDODs(nDIs) = nDODs(nDIs) + 1
         DOD_Description(nDIs, nDODs(nDIs)) = buffer
         Input #1, DOD_Expected(nDIs, nDODs(nDIs)), DOD_Lower(nDIs, nDODs(nDIs)), DOD_Upper(nDIs, nDODs(nDIs))
         
         
         nDOD_Examples(nDIs, nDODs(nDIs)) = 0
         pattern = DI_ID(nDIs) & "_" & Format$(nDODs(nDIs), "00") & "*.jpg"
         buffer = Dir("Examples\" & pattern)
         While buffer <> ""
           nDOD_Examples(nDIs, nDODs(nDIs)) = nDOD_Examples(nDIs, nDODs(nDIs)) + 1
           Set DOD_Example(nDIs, nDODs(nDIs), nDOD_Examples(nDIs, nDODs(nDIs))) = LoadPicture("Examples\" & buffer)
           buffer = Dir
         Wend
         
       Loop
       
    Loop
    
    frmSpash.Hide
    
    
End Sub

Sub Change_DI()

       
   txtBigText.Visible = False
       
   picPic = DI_Example(DI)
   
   txtTxt.FontSize = 8
   txtTxt = DI_Title(DI) & "    " & DI_Description_Short(DI)
 
   SHOWDOD = False
   sbDOD.Max = 0
   sbDOD.Min = nDODs(DI)
   sbDOD.Value = 0
   SHOWDOD = True
   
   txtTxt.BackColor = RGB(255, 255, 192)
   
   lineDIdown.Visible = (DI > 1)
   lineDIup.Visible = (DI < nDIs)
   
   lineDODup.Visible = True
   lineDODdown.Visible = False
   
   lineExampleUp.Visible = False
   lineExampleDown.Visible = False
   

End Sub

Sub Change_DOD()
Dim h As Integer

  frameExamples.Visible = False
  
  frameResult.Visible = (DOD > 0)
  frameTune.Visible = (DOD > 0)

  If Not SHOWDOD Then Exit Sub

     
  txtBigText.Visible = False
  
  
  lineDODup.Visible = (DOD < nDODs(DI))
  lineDODdown.Visible = (DOD > 0)
  
  
  If DOD = 0 Then
    picPic = DI_Example(DI)
    txtTxt.FontSize = 8
    txtTxt = DI_Title(DI) & "    " & DI_Description_Short(DI)
  Else
  
   '============
   
    picPic = DOD_Example(DI, DOD, 1)
 
    On Error Resume Next
    h = DOD_Example(DI, DOD, 1).Height
    If Err Then
      txtBigText = DI_ID(DI) & "     DOD " & DOD & vbCrLf & vbCrLf & DOD_Description(DI, DOD)
      txtBigText.Visible = True
    End If
    On Error GoTo 0
    
    txtTxt.FontSize = 16
    txtTxt = DI_ID(DI) & "   DOD " & DOD & "       " & DOD_Description(DI, DOD)
      
    lblUpper = DOD_Upper(DI, DOD)
    lblLower = DOD_Lower(DI, DOD)
    
    sbFineTune.Min = DOD_Upper(DI, DOD)
    sbFineTune.Max = DOD_Lower(DI, DOD)
    sbFineTune.Value = DOD_Expected(DI, DOD)
    
    If nDOD_Examples(DI, DOD) > 1 Then
      frameExamples.Visible = True
    
      SHOWEXAMPLE = False
      sbExample.Max = 1
      sbExample.Min = nDOD_Examples(DI, DOD)
      sbExample.Value = 1
      SHOWEXAMPLE = True
      
      lineExampleUp.Visible = True
      lineExampleDown.Visible = False
    Else
      lineExampleUp.Visible = False
      lineExampleDown.Visible = False
    End If
    
    
  End If
    
End Sub

Private Sub btnHelp_Click()
    ShowHelp = Not ShowHelp
    LineHelp1.Visible = ShowHelp
    LineHelp2.Visible = ShowHelp
    LineHelp3.Visible = ShowHelp
    
    lblHelp1.Visible = ShowHelp
    lblHelp2.Visible = ShowHelp
    lblHelp3.Visible = ShowHelp
    lblHelp4.Visible = ShowHelp
    lblHelp5.Visible = ShowHelp
    lblHelp6.Visible = ShowHelp
    
End Sub

Private Sub btnReference_Click()
Dim result
    result = ShellExecute(0&, vbNullString, "http://www.wind.ttu.edu/EFScale.pdf", vbNullString, vbNullString, vbNormalFocus)
    
    If result = 1 Then
    End If
End Sub

Private Sub Form_Load()
    ShowHelp = False

    LoadConfiguration
    DI = 1
    sbDI.Max = 1
    sbDI.Min = nDIs
    sbDI.Value = 1
    
    'Change_DI not required
End Sub

Private Sub Label6_Click()

End Sub

Private Sub lblHelp1_Click()
   If DI < nDIs Then sbDI = sbDI + 1
End Sub

Private Sub lblHelp2_Click()
    If DI > 1 Then sbDI = sbDI - 1
End Sub

Private Sub lblHelp3_Click()
     If DOD < nDODs(DI) Then sbDOD = sbDOD + 1
End Sub

Private Sub lblHelp4_Click()
    If DOD > 0 Then sbDOD = sbDOD - 1
End Sub

Private Sub lblHelp5_Click()
    If frameExamples.Visible Then
       If sbExample.Value < sbExample.Min Then sbExample.Value = sbExample.Value + 1
    End If
End Sub

Private Sub lblHelp6_Click()
    If frameExamples.Visible Then
      If sbExample.Value > 1 Then sbExample.Value = sbExample.Value - 1
    End If
End Sub

Private Sub picPic_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim third As Integer, half As Integer

  third = Int(3# * X / picPic.Width)
  half = Int(2# * Y / picPic.Height)


  Select Case third
    Case 2
      If half = 0 Then
        If DI < nDIs Then sbDI = sbDI + 1
      Else
        If DI > 1 Then sbDI = sbDI - 1
      End If
    Case 1
      If half = 0 Then
        If DOD < nDODs(DI) Then sbDOD = sbDOD + 1
      Else
        If DOD > 0 Then sbDOD = sbDOD - 1
      End If
    Case 0
      If frameExamples.Visible Then
        If half = 0 Then
          If sbExample.Value < sbExample.Min Then sbExample.Value = sbExample.Value + 1
        Else
          If sbExample.Value > 1 Then sbExample.Value = sbExample.Value - 1
        End If
      End If
  End Select
  
End Sub

Private Sub sbDI_Change()
    DI = sbDI.Value
    Change_DI
End Sub


Private Sub sbDI_Scroll()
    sbDI_Change
End Sub

Private Sub sbDOD_Change()
    DOD = sbDOD.Value
    Change_DOD
End Sub

Private Sub sbDOD_Scroll()
  sbDOD_Change
End Sub

Private Sub sbExample_Change()

  If SHOWEXAMPLE Then
    picPic = DOD_Example(DI, DOD, sbExample)
    
    lineExampleUp.Visible = (sbExample < nDOD_Examples(DI, DOD))
    lineExampleDown.Visible = (sbExample > 1)
  End If
  
End Sub

Private Sub sbExample_Scroll()
  sbExample_Change
End Sub

Private Sub sbFineTune_Change()
Dim delta As Single
Dim span As Integer, spanHigh As Integer, spanLow As Integer

    txtWind = sbFineTune.Value
    txtEF = Wind_To_EF(txtWind)
    
'  The Final Readout
    
    If DOD = nDODs(DI) Then
      If DOD_Upper(DI, DOD) <= 200 Then
        txtEF = txtEF & "+"
      End If
    End If
    
    spanHigh = DOD_Upper(DI, DOD) - DOD_Expected(DI, DOD)
    spanLow = DOD_Expected(DI, DOD) - DOD_Lower(DI, DOD)
    If spanHigh > spanLow Then
      span = spanHigh
    Else
       span = spanLow
    End If
    delta = 1 - 0.8 * Abs(sbFineTune.Value - DOD_Expected(DI, DOD)) / span
    If delta < 0 Then delta = 0
    
    txtTxt.BackColor = RGB(255, 255 * delta, 192 * delta)
    
End Sub

Private Sub sbFineTune_Scroll()
    sbFineTune_Change
End Sub

Private Sub txtBigText_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

Dim third As Integer, half As Integer

  third = Int(3# * X / txtBigText.Width)
  half = Int(2# * Y / txtBigText.Height)

  Select Case third
    Case 2
      If half = 0 Then
        If DI < nDIs Then sbDI = sbDI + 1
      Else
        If DI > 1 Then sbDI = sbDI - 1
      End If
    Case 1
      If half = 0 Then
        If DOD < nDODs(DI) Then sbDOD = sbDOD + 1
      Else
        If DOD > 0 Then sbDOD = sbDOD - 1
      End If
    Case 0
      If frameExamples.Visible Then
        If half = 0 Then
          If sbExample.Value < sbExample.Min Then sbExample.Value = sbExample.Value + 1
        Else
          If sbExample.Value > 1 Then sbExample.Value = sbExample.Value - 1
        End If
      End If
  End Select
  


End Sub

Private Sub txtTxt_Click()
  frmZoom.Show
End Sub
